USE University;

--LIST name and surname of Bachelor students 
--attending years greater than 1

select students.studentID, students.name AS name_stud, 
students.surname AS surname_stud
from students
where students.year > 1 and students.program='bachelor'; 

--List StudentID and surname of students who did the exam 
--of programming
-- tables: students, exams, courses
SELECT s.studentID, s.surname
FROM students s JOIN exams e ON s.studentID=e.student 
JOIN Courses c ON c.code=e.course
WHERE c.title = 'programming';

-- Surname and name of all people in the database
--tables: students and teachers

select surname, name 
from teachers 
UNION ALL
select surname, name
from  students

-- Students attending years greater than 1 and exams with laud
-- tables: students, exams

SELECT  distinct s.studentID, s.surname, s.name
FROM students s JOIN exams e ON s.studentID=e.student 
where s.year > 1 and e.laud='True';

--Surname and name of researcher professors who 
--are supervisors of bachelor theses
--tables: students and teachers


Select DISTINCT t.code, t.surname AS TeacherSurname, t.name AS TeacherName
from students s join teachers t on t.code = s.supervisor
where t.role ='researcher' and s.program='bachelor'

--Surname and name of researcher professors who 
--are supervisors of bachelor theses. Return also the surname and name
--of students
--tables: students and teachers
Select t.surname AS TeacherSurname, t.name AS TeacherName, 
s.surname AS Stu_Surname, s.name as Stu_name
from students s join teachers t on t.code = s.supervisor
where t.role ='researcher' and s.program='bachelor'


--List teachers supervisioning students having at least 
-- one mark less than 25 or students with a mark greater than 29.
--Tables: students, exams, teachers

Select distinct t.code, t.surname, t.name
from students s join teachers t on t.code = s.supervisor JOIN
exams e ON s.studentID = e.student
WHERE e.mark < 25 OR e.mark > 29

-- RETURN teachers who are not supervisioning bachelor students
Select *
from teachers 
where code NOT IN (
select supervisor
from students 
where program='bachelor' and supervisor is not null)

--List the tutors who in databases exam have a greater 
--mark than at least one of their students
-- tables: tutoring, students (tutor), exams (tutor), courses, 
-- students (student), exams (student)
select distinct s.studentID, s.name, s.surname
from tutoring t join students s on s.studentID=t.tutor JOIN
exams e ON t.tutor=e.student join courses c on c.code=e.course 
JOIN Students ss on ss.studentID=t.student 
JOIN exams es on es.student=ss.studentID
where c.title='databases' and e.mark > es.mark and e.course=es.course 




