use University;

select *
from Teachers

select *
from Courses


--1. For each course, its names and the related professor's name
SELECT c.code, c.title, t.surname, t.name
FROM Courses c JOIN Teachers t ON c.teacher=t.code

--equivalent but not necessary
SELECT c.code, c.title, t.surname, t.name
FROM Courses c JOIN Teachers t ON c.teacher=t.code
group by c.code,  c.title, t.surname, t.name

--2. For each student, the name and the number of exams, avarege mark
Select s.surname, s.name, count(*) AS nExams, avg(mark*1.0) AS AVGMARK
from Students s join exams e on s.studentID=e.student
group by s.studentID, s.surname, s.name


--3. For each professor, his name and the number of exams

select t.code,t.surname, t.name, count(*) AS NExams 
from Teachers t join Courses c ON c.teacher=t.code join 
Exams e ON e.course=c.code
group by t.code, t.surname, t.name;

--4. For each student of the first year, the name and the average grade

Select s.surname, s.name, avg(mark*1.0) AS AVGMARK
from Students s join exams e on s.studentID=e.student
where s.year = 1
group by s.studentID, s.surname, s.name


--5. For each student, the name and average mark
-- only if the mark is greater than 27. Order the result wrt the 
--surname and name in ascending order

Select s.surname, s.name, avg(mark*1.0) AS AVGMARK
from Students s join exams e on s.studentID=e.student
where mark > 27
group by s.studentID, s.surname, s.name
order by s.surname, s.name

--6. For each student, the name and average mark
-- only if the average mark is greater than 27 
Select s.surname, s.name, avg(mark*1.0) AS AVGMARK
from Students s join exams e on s.studentID=e.student
group by s.studentID, s.surname, s.name
HAVING avg(mark*1.0) > 27;

--7. For each student, the name and average mark
-- only if the number of exams is greater than 1 
Select s.surname, s.name, avg(mark*1.0) AS AVGMARK
from Students s join exams e on s.studentID=e.student
group by s.studentID, s.surname, s.name
HAVING count(*) > 1



